Name: openmpi
Version: 1.2.5
Release: alt1.1

%define mpi_prefix %_libdir/%name
%define mpi_sysconfdir %_sysconfdir/%name

Summary: A powerful implementaion of MPI
Summary(ru_RU.UTF8): Открытая реализация MPI
License: BSD
Group: Development/Other
Url: http://www.open-mpi.org/

Packager: Denis Pynkin <dans@altlinux.ru>
Source: %name-%version.tar
Source1: %name-alt-as-needed.patch
Source2: MPI_Status_c2f.3

BuildPreReq: mpi-selector
Requires(post,preun): mpi-selector

BuildRequires: /proc flex gcc-c++ gcc-g77 libstdc++-devel-static libibverbs-devel libdapl-devel


%package devel
Summary: Development part of %name
Group: Development/Other

Requires: %name = %version-%release
Requires: gcc-c++ gcc-g77
Requires: libibverbs-devel libibumad-devel 

# do not include requires to libibverbs by default
%add_findreq_skiplist /usr/lib/libmpi.so*

%description
Open MPI is a project combining technologies and resources from
several other projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in
order to build the best MPI library available. A completely new
MPI-2 compliant implementation, Open MPI offers advantages for
system and software vendors, application developers and computer
science researchers.

This part is attended for computing nodes.
#description -l ru_RU.KOI8-R

%description devel
Package for development with Open MPI 

%prep
%setup -q
%__cp %SOURCE1 ./
%__cp -f %SOURCE2 ompi/mpi/man/man3/

%build
CFLAGS="-D_FORTIFY_SOURCE=2"
echo="/bin/echo"
export CFLAGS echo

%__autoreconf
./configure \
    --disable-mpi-f90 \
    --disable-dlopen \
    --prefix=%mpi_prefix \
    --enable-orterun-prefix-by-default \
    --sysconfdir=%mpi_sysconfdir \
    --bindir=%mpi_prefix/bin \
    --libdir=%mpi_prefix/lib \
    --datadir=%mpi_prefix/data \
    --includedir=%mpi_prefix/include \
    --mandir=%mpi_prefix/man
    
%make_build

# part below needed for correct linking without unresolved symbols
%__patch -p1 <%SOURCE1

#strange behavior - pushd/popd just ignored ?
cd ompi/mpi/
%make clean
%make_build
cd ../..


%install
echo="/bin/echo"
export echo

#added for relink operation for libmpi_cxx.so and libmpi_f77.so
%__mkdir_p %buildroot%mpi_prefix/lib
%__cp -a ompi/.libs/libmpi.so* %buildroot%mpi_prefix/lib

%make_install DESTDIR=%buildroot install
%find_lang %name

echo -e "btl = tcp,self\n" >> %buildroot%mpi_sysconfdir/openmpi-mca-params.conf

cat>%buildroot/%mpi_prefix/bin/mpivars.sh<<EOF
if ! echo \$PATH | grep -q %mpi_prefix/bin ; then
    PATH=%mpi_prefix/bin:\$PATH
    export PATH
fi

if ! echo \$LD_LIBRARY_PATH | grep -q %mpi_prefix/lib ; then
    LD_LIBRARY_PATH=%mpi_prefix/lib:\$LD_LIBRARY_PATH
    export LD_LIBRARY_PATH
fi

if ! echo \$MANPATH | grep -q %mpi_prefix/man ; then
    MANPATH=%mpi_prefix/man:\$MANPATH
    export MANPATH
fi
EOF

cat >%buildroot%mpi_prefix/bin/mpivars.csh <<EOF
if (\$?path) then
    if ( "\${path}" !~ *%mpi_prefix/bin* ) then
	set path = ( %mpi_prefix/bin \$path )
    endif
else
    set path = ( %mpi_prefix/bin )
endif

if (\$?LD_LIBRARY_PATH) then
    if ( "\$LD_LIBRARY_PATH" !~ *%mpi_prefix/lib* ) then
	setenv LD_LIBRARY_PATH %mpi_prefix/lib:\$LD_LIBRARY_PATH
    endif
else
    setenv LD_LIBRARY_PATH %mpi_prefix/lib:
endif

if (\$?MANPATH) then
    if ( "\$MANPATH" !~ *%mpi_prefix/man* ) then
	setenv MANPATH %mpi_prefix/man:\$MANPATH
    endif
else
    setenv MANPATH %mpi_prefix/man:
endif
EOF

%post
%post_mpi_selector %name %mpi_prefix/bin

%preun
%preun_mpi_selector %name

%files -f %name.lang
%doc AUTHORS LICENSE NEWS README VERSION 

%dir %mpi_prefix

%mpi_prefix/bin/mpivars.*
%mpi_prefix/bin/mpirun
%mpi_prefix/bin/ompi_info
%mpi_prefix/bin/opal_wrapper
%mpi_prefix/bin/orted
%mpi_prefix/bin/orterun

%mpi_prefix/lib/openmpi/*
%mpi_prefix/lib/libmpi.so.*
%mpi_prefix/lib/libopen-rte.so.*
%mpi_prefix/lib/libopen-pal.so.*

%dir %mpi_sysconfdir
%config(noreplace) %mpi_sysconfdir/*

%mpi_prefix/man/man1
%mpi_prefix/data

%files devel
%mpi_prefix/bin/mpic++
%mpi_prefix/bin/mpicc
%mpi_prefix/bin/mpiCC
%mpi_prefix/bin/mpicxx
%mpi_prefix/bin/mpiexec
%mpi_prefix/bin/mpif77
%mpi_prefix/bin/mpif90

%mpi_prefix/include/*
%mpi_prefix/man/man3
%mpi_prefix/lib/libmpi_cxx.*
%mpi_prefix/lib/libmpi_f77.*
%mpi_prefix/lib/libmpi.so
%mpi_prefix/lib/libopen-rte.so
%mpi_prefix/lib/libopen-pal.so


%changelog
* Thu Jan 31 2008 Stanislav Ievlev <inger@altlinux.org> 1.2.5-alt1.1
- add mpi-selector support

* Wed Jan 16 2008 Denis Pynkin <dans@altlinux.ru> 1.2.5-alt1
- New verion.
- Many bug fixes.

* Mon Oct 01 2007 Denis Pynkin <dans@altlinux.ru> 1.2.4-alt2
- added autoreconf (tnx to Lost for advice)

* Wed Sep 26 2007 Denis Pynkin <dans@altlinux.ru> 1.2.4-alt1
- new version

* Fri Aug 24 2007 Denis Pynkin <dans@altlinux.ru> 1.2.3-alt4
- libdapl-devel to buildrequires by S.Ievlev's request
- auto test of infiniband card

* Thu Aug 23 2007 Denis Pynkin <dans@altlinux.ru> 1.2.3-alt3
- added libibverbs to buildrequires by S.Ievlev's request
- added /proc to buildrequires to build component linux:timer

* Tue Jun 26 2007 Denis Pynkin <dans@altlinux.ru> 1.2.3-alt2
- Added devel package
- Added openmpi-alt-as-needed.patch
- Fix of unresolved symbols

* Tue Jun 26 2007 Denis Pynkin <dans@altlinux.ru> 1.2.3-alt1
- This release is mainly a bug fix release over the v1.2.2
  release, but there are few minor new features.

* Thu May 17 2007 Denis Pynkin <dans@altlinux.ru> 1.2.2-alt1
- This release is mainly a bug fix release over the v1.2.1
  release, but there are few minor new features.

* Thu Apr 26 2007 Denis Pynkin <dans@altlinux.ru> 1.2.1-alt1
- This release is mainly a bug fix release over the
  v1.2 release, but there are few minor new features. 

* Thu Mar 22 2007 Denis Pynkin <dans@altlinux.ru> 1.2.0-alt1
- This release contains many bug fixes, feature
  enhancements, and performance improvements over the v1.1 series
- added echo variable for properly working libtool
- added --disable-dlopen in configuration
- taken ompi/mpi/man/man3/MPI_Status_c2f.3 from package 'lam'
  because of broken version in release

* Wed Mar 21 2007 Denis Pynkin <dans@altlinux.ru> 1.1.5-alt1
- Version 1.1.5 is expected (hoped) to be the last release in the v1.1 series

* Wed Jan 31 2007 Denis Pynkin <dans@altlinux.ru> 1.1.4-alt1
- The 1.1.4 release is what the 1.1.3 release should have been.

* Tue Jan 30 2007 Denis Pynkin <dans@altlinux.ru> 1.1.3-alt1
- This release is mainly a bug fix release over the 1.1.2 release.

* Tue Jan 02 2007 Denis Pynkin <dans@altlinux.ru> 1.1.2-alt2
- added /usr/share/openmpi/* to package

* Tue Dec 26 2006 Denis Pynkin <dans@altlinux.ru> 1.1.2-alt1
- Initial build for ALTLinux.
